﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows;
using System.Collections;


namespace SilverlightTreeViewEdit
{
    public partial class MainPage : UserControl
    {
        //  TreeViewDataSource treeSource;
		bool isEditAllowed = false;
        public MainPage()
        {
            InitializeComponent();

            this.treeViewDepartments.AddHandler(RadMenuItem.ClickEvent, new RoutedEventHandler(OnMenuItemClicked));

			//this.treeViewDepartments.AddHandler(RadTreeViewItem.KeyDownEvent, new KeyEventHandler(treeViewDepartments_KeyDown),true);
			//this.treeViewDepartments.AddHandler(RadTreeView.KeyDownEvent, new KeyEventHandler(treeViewDepartments_KeyDown), true);

            //  treeSource = new TreeViewDataSource();
        }

        private void ContextMenuOpened(object sender, RoutedEventArgs e)
        {
            RadTreeViewItem treeViewItem = (sender as RadContextMenu).GetClickedElement<RadTreeViewItem>();

            if (treeViewItem == null)
            {
                (sender as RadContextMenu).IsOpen = false;
                return;
            }

            if (!treeViewItem.IsSelected)
            {
                treeViewDepartments.SelectedItems.Clear();
                treeViewDepartments.SelectedItems.Add(treeViewItem.Item);
            }
        }

        private void OnMenuItemClicked(object sender, RoutedEventArgs args)
        {
            RadRoutedEventArgs e = args as RadRoutedEventArgs;
            RadMenuItem item = e.OriginalSource as RadMenuItem;
            if ((item == null))
            {
                return;
            }
            switch (item.Header.ToString())
            {
                case "Add New Item":
                    this.AddItem();
                    break;
                case "Remove Item":
                    this.RemoveItem();
                    break;
                case "Edit Item":
                    this.EditItem();
                    break;
            }
        }

        private void AddItem()
        {
            RadTreeViewItem treeViewItem = treeViewDepartments.SelectedContainer;

            if (treeViewItem.Item is Organization)
            {
                (treeViewItem.Item as Organization).Departments.Add(new Department("New Department"));
            }
            else
                (treeViewItem.Item as Department).SubDepartments.Add(new Department("New Department"));

            treeViewItem.IsExpanded = true;
        }

        private void RemoveItem()
        {
            while (treeViewDepartments.SelectedItems.Count > 0)
            {
                RadTreeViewItem treeViewItem = treeViewDepartments.ContainerFromItemRecursive(treeViewDepartments.SelectedItems[0]);

                if (treeViewItem == null)
                {
                    return;
                }
                if (treeViewItem.ParentItem is RadTreeViewItem)
                {
                    ((treeViewItem.ParentItem as RadTreeViewItem).ItemsSource as IList).Remove(treeViewItem.Item);
                }
                else
                {
                    (this.treeViewDepartments.ItemsSource as IList).Remove(treeViewItem.Item);
                }
            }
        }

        private void EditItem()
        {
			isEditAllowed = true;
            RadTreeViewItem treeViewItem = treeViewDepartments.SelectedContainer;
            treeViewItem.BeginEdit();

        }

		private void treeViewDepartments_PreviewEditStarted(object sender, RadTreeViewItemEditedEventArgs e)
		{
			if (!isEditAllowed)
				e.Handled = true;
		}

		private void treeViewDepartments_Edited(object sender, RadTreeViewItemEditedEventArgs e)
		{
			isEditAllowed = false;
		}
 
    }

}
